/** @file
********************************************************************************
<PRE>
ģ: ʱٸҶ任
ļ: FFT2.c
ļ: FFT2.h
ļʵֹ: ʱٸҶ任غʵ
--------------------------------------------------------------------------------
̰߳ȫ: </>[˵]
쳣ʱȫ: </>[˵]
--------------------------------------------------------------------------------
ע: <˵>
--------------------------------------------------------------------------------
޸ļ¼:
         汾     ޸              ޸
YYYY/MM/DD   X.Y      <߻޸>    <޸>
</PRE>
*******************************************************************************/
#include "stdafx.h"
#include "FFT2.h"



// ˷
static void EE(COMPX b1, COMPX b2, COMPX  * result)
{
	result->real = b1.real*b2.real - b1.imag*b2.imag;
	result->imag = b1.real*b2.imag + b1.imag*b2.real;
}


void FFT2(COMPX  * xin, int N)
{
	int f, m, LH, nm, i, k, j, L;
	double p, ps;
	int le, B, ip;
	COMPX w, t;

	LH = N / 2;
	f = N;
	for (m = 1; (f = f / 2) != 1; ++m)
	{
		;
	}
	nm = N-2;
	j = N / 2;
	/* ַ */
	for (i = 1; i <= nm; ++i)
	{
		if (i < j)
		{
			t = xin[j];
			xin[j] = xin[i];
			xin[i] = t;
		}
		k = LH;
		while (j >= k)
		{
			j = j - k;
			k = k / 2;
		}
		j = j + k;
	}

	{
		for (L = 1; L<=m; L++)
		{
			le = (int)pow(2.0, L);
			B = le / 2;
			for (j = 0; j <= B - 1; j++)
			{
				p = pow(2.0, m-L) * j;
				ps = 2 * PI/ N * p;
				w.real = cos(ps);
				w.imag = -sin(ps);
				for (i = j; i <= N-1; i = i + le)
				{
					ip = i + B;
					EE(xin[ip], w, &t);
					xin[ip].real = xin[i].real - t.real;
					xin[ip].imag = xin[i].imag - t.imag;
					xin[i].real = xin[i].real + t.real;
					xin[i].imag = xin[i].imag + t.imag;
				}
			}
		}
	}
	return;
}


/*****************main programe********************/

//#include <math.h>
//#include <stdio.h>
//#include <stdlib.h>
//
//float  result[257];
//COMPX  s[257];
//int   Num=16;
//const float pp=3.14159;
//
//main()
//{
//
//	int i;
//	for(i=0;i<16;i++)   //ʼź
//	{
//		s[i].real=sin(pp*i/32);
//		s[i].imag=0;
//	}
//
//	FFT(s,Num);
//
//	for(i=0;i<16;i++)
//	{
//		printf("%.4f",s[i].real);
//		printf("+%.4fj\n",s[i].imag);
//		result[i]=sqrt(pow(s[i].real,2)+pow(s[i].imag,2));
//	}
//}
